<?php
$title = "Flash";

require 'include/header.php';
require 'include/util.php';

$db = sqlite_open("avrweb.sqlite");

$part_shorthand = sqlite_single_query($db, "SELECT value FROM settings WHERE setting = 'part'");
$result = sqlite_unbuffered_query($db, "SELECT * FROM parts WHERE shorthand = '$part_shorthand'");
$part = sqlite_fetch_array($result);
$dude = avrdude($db, "-v");
?>

<div data-role="content">	
	
<h1>Flash <?= $part['description'] ?> (<?= $part['id'] ?>)</h1>

<?php
$fuses = array(
	'FUSE_LOW' => array('lfuse', 'low fuse'),
	'FUSE_HIGH' => array('hfuse', 'high fuse'),
	'FUSE_EXTENDED' => array('efuse', 'extended fuse'),
);

$fuse_vals = array();
$set_fuses = array();
$output = array();

foreach($fuses as $name => $short_desc) {
	if(!$_POST[$name] || substr($_POST[$name], 0, 2) != '0x')
		continue;
		
	preg_match("/" . $short_desc[0] . " reads as ([0-9A-Z]{1,2})/", $dude, $matches);
	
	if($matches && $_POST[$name] == '0x'.$matches[1]) // no change
		continue;

	$set_fuses[] = '-U ' . $short_desc[0] . ':w:' . $_POST[$name] . ':m';
	$output[] = $short_desc[1] . ' to ' . $_POST[$name];
}
?>

<?php if(count($set_fuses)): ?>
<p>Setting the following fuses: <?= join(', ', $output) ?>. AVRdude output:</p>

<pre>
&gt; avrdude <?= join(' ', $set_fuses) ?>
<?php
echo avrdude($db, join(' ', $set_fuses));
?>
</pre>
<?php else: ?>
<p>No fuse value changes detected. Skipping flash.</p>
<?php endif; ?>

<a href="/" data-role="button" data-theme="b">OK</a>

</div><!-- /content -->

<?php
sqlite_close($db);
require 'include/footer.php';
?>
