<?php
$title = "MCU identification";
$no_header = TRUE;

require 'include/header.php';
require 'include/util.php';

$db = sqlite_open("avrweb.sqlite");
?>

<div data-role="content">	
	
<!--h1><?= $title ?></h1-->

<?php
# will print out an error message if there's connection issues
$output = avrdude_no_part($db, "-p attiny2313"); 
?>

<?php if($output && preg_match("/avrdude: Device signature = 0x(\w+)/", $output, $matches)): ?>
	<p>Found device with signature <?= strtoupper($matches[1]) ?>, check parts...</p>
	
	<?php
	$result = sqlite_query($db, "SELECT shorthand, description FROM parts WHERE signature = '" .
		strtoupper($matches[1]) . "'");
	$part = sqlite_fetch_array($result);
	?>
	
	<?php if(sqlite_num_rows($result) > 0): ?>
	<ul data-role="listview" data-inset="true" data-divider-theme="b">
		<li data-role="list-divider"><?= $part['description'] ?></li>
		<li>Shorthand: <?= $part['shorthand'] ?></li>
	</ul>
	
	<?php
	sqlite_query($db, "DELETE FROM settings WHERE setting = 'part'");
	sqlite_query($db, "INSERT INTO settings (setting, value) VALUES ('part', '" .
		$part['shorthand'] . "')");
	sqlite_query($db, "DELETE FROM settings WHERE setting = 'part_long'");
	sqlite_query($db, "INSERT INTO settings (setting, value) VALUES ('part_long', '" .
		$part['description'] . "')");
	?>
	
	<p>Part settings saved. AVRweb will now use assume this device is connected until you re-identify.</p>
	<?php else: ?>
	<p>Matching part not found from database. Part settings not changed.</p>
	<?php endif; ?>
	
<?php endif; ?>

<a href="index.php" data-role="button" data-inline="true" data-ajax="false" data-theme="b">OK</a>

</div><!-- /content -->

<?php
sqlite_close($db);
require 'include/footer.php';
?>
