<?php
function avrdude_no_part($db, $commands) {
	$programmer = sqlite_single_query($db, "SELECT value FROM settings WHERE setting = 'programmer'");
	$prog_opts = sqlite_single_query($db, "SELECT value FROM settings WHERE setting = 'prog_opts'");
	exec("avrdude -c $programmer $prog_opts $commands 2>&1", $output);
	$output = join("\n", $output);
	
	if(preg_match("/avrdude: Error: Could not find/", $output)) {
		echo "<p>Could not find the programmer. Please your programmer is properly connected to the computer.</p>";
		return 0;
	} elseif(preg_match("/avrdude: initialization failed/", $output)) {
		echo "<p>Initialization of MCU failed. Check programmer connections to the device.</p>";
		return 0;
	}
	
	return $output;
}

function avrdude($db, $commands) {
	$part = sqlite_single_query($db, "SELECT value FROM settings WHERE setting = 'part'");
	
	if(!$part) {
		echo "<p>Part not set. Please <a href=\"identify.php\">identify</a> your MCU first.</p>";
		return 0;
	}
	
	return avrdude_no_part($db, "-p $part $commands");
}
?>