<?php
$title = "Set fuses";

require 'include/header.php';

$db = sqlite_open("avrweb.sqlite");

$part = sqlite_single_query($db, "SELECT value FROM settings WHERE setting = 'part'");
$part_long = sqlite_single_query($db, "SELECT value FROM settings WHERE setting = 'part_long'");

$result = squeal($db,"SELECT * FROM parts ORDER BY description");

function squeal($db, $sql) {
	if(!($ret = sqlite_unbuffered_query($db, $sql))) {
		echo "<p>Virhe: " . sqlite_error_string(sqlite_last_error()) . "</p>";
		exit;
	}
	
	return $ret;
}

squeal($db, "DELETE FROM part_fuses");
squeal($db, "DELETE FROM fuse_bitfields");
squeal($db, "DELETE FROM bitfields");
squeal($db, "DELETE FROM bitfield_enums");
squeal($db, "DELETE FROM bitfield_enum_values");
?>

<div data-role="content">	
<?php while(($part=sqlite_fetch_array($result))): ?>
	<h2><?= $part['description'] ?></h2>
	<?php if(!file_exists("../devices/${part['description']}.xml")): ?>
	<p>No part file, skipping...</p>
	<?php else: ?>
	<p>Parsing...</p>
	<?php
	$xml = simplexml_load_file("../devices/${part['description']}.xml");

	foreach(($xml->modules[0]->module) as $module) {
		if($module["name"] != "FUSE")
			continue;
			
		$enums = array();
		
		foreach($module->{"value-group"} as $values) {
			$enum_name = (string)$values["name"];
			$enum_vals = array();
			$enum_str = array();
			
			foreach($values->value as $value) {
				$enum_vals[] = array(
					'caption' => (string)$value["caption"],
					'name' => (string)$value["name"],
					'value' => hexdec((string)$value["value"]),
				);
				$enum_str[] = (string)$value["caption"] .
					(string)$value["name"] .
					(string)$value["value"];
			}
			
			$enum_md5 = md5(join("", $enum_str));
			
			$enum_id = sqlite_single_query($db, "SELECT id FROM bitfield_enums WHERE name = '$enum_name' AND md5 = '$enum_md5'");
			
			if($enum_id) {
				$enums[$enum_name] = $enum_id;
			} else {
				squeal($db, "INSERT INTO bitfield_enums (name, md5) VALUES ('$enum_name', '$enum_md5')");
				$enums[$enum_name] = $enum_id = sqlite_last_insert_rowid($db);
				foreach($enum_vals as $value) {
					squeal($db, "INSERT INTO bitfield_enum_values (bitfield_enum_id, caption, name, value) VALUES ('" .
						$enum_id . "', '" .
						$value['caption'] . "', '" .
						$value['name'] . "', '" .
						$value['value'] . "')");
				}
			}
		}
				
		foreach($module->{"register-group"}->register as $register) {
			echo "<h3>Fuse: " . $register["name"] . "</h3>\n";
			
			squeal($db, "INSERT INTO part_fuses (part_id, name) VALUES ('" .
				$part['id'] . "', '" . $register["name"] . "')");
			$fuse_id = sqlite_last_insert_rowid($db);
			
			foreach($register->bitfield as $bitfield_elem) {
				$bitfield = array(
					'name' => (string)$bitfield_elem["name"],
					'caption' => (string)$bitfield_elem["caption"],
					'mask' => hexdec((string)$bitfield_elem["mask"]),
					'enum_id' => "0"
				);
				
				if($bitfield_elem["values"])
					$bitfield['enum_id'] = $enums[(string)$bitfield_elem["values"]];
					
				$bitfield_id = sqlite_single_query($db, "SELECT id FROM bitfields WHERE name = '" .
					$bitfield['name'] . "' AND caption = '" .
					$bitfield['caption'] . "' AND mask = '" .
					$bitfield['mask'] . "' AND bitfield_enum_id = '" .
					$bitfield['enum_id'] . "'");
				
				if(!$bitfield_id) {
					squeal($db, "INSERT INTO bitfields (name, caption, mask, bitfield_enum_id) VALUES ('" .
						$bitfield['name'] . "', '" .
						$bitfield['caption'] . "', '" .
						$bitfield['mask'] . "', '" .
						$bitfield['enum_id'] . "')");
					$bitfield_id = sqlite_last_insert_rowid($db);
				}
				
				squeal($db, "INSERT INTO fuse_bitfields (fuse_id, bitfield_id) VALUES " .
					"($fuse_id, $bitfield_id)");
			}		
		}
	}
	?>
	<?php endif; ?>

<?php endwhile; ?>

</div><!-- /content -->

<?php
sqlite_close($db);
require 'include/footer.php';
?>
