<?php
$title = "Enum tester";

require 'include/header.php';

$db = sqlite_open("avrweb.sqlite");

$result = sqlite_unbuffered_query($db, "SELECT * FROM bitfield_enums");

function mask2shift($mask) {
	if($mask < 1)
		return 0; // error condition
		
	for($shift = 0; !($mask & (1<<$shift)); $shift++);
	
	return $shift;
}
?>

<div data-role="content">	

<?php while($enum = sqlite_fetch_array($result)): ?>
	<h2><?= $enum['name'] ?> (<?= $enum['id'] ?>)</h2>

<?php 
$sql = "SELECT * FROM bitfield_enum_values WHERE bitfield_enum_id = " . $enum['id']; 
$result2 = sqlite_unbuffered_query($db, $sql);
#echo "<p>$sql</p>";

$min = 256;
$max = 0;
$mask = 0;

echo "<!-- Actual values:\n";

while($value = sqlite_fetch_array($result2)) {
	$val = (int)$value['value'];
	$min = min($min, $val);
	$max = max($max, $val);
	$mask |= $val;
	echo str_pad(decbin($val), 8, "0", STR_PAD_LEFT) . "\n";
}

echo "-->";
echo "<p>Values between $min and $max (" . decbin($min) . " - " . decbin($max) . "), mask " . decbin($mask) . "</p>";
?>
	
	<!-- MD5: <?= $enum['md5'] ?> -->
<?php 
$sql = "SELECT b.mask, b.name, f.name AS fuse, p.description FROM bitfields AS b " .
	"INNER JOIN fuse_bitfields AS fb ON fb.bitfield_id = b.id " .
	"INNER JOIN part_fuses AS f ON fb.fuse_id = f.id " .
	"INNER JOIN parts AS p ON f.part_id = p.id " .
	"WHERE b.bitfield_enum_id = " . $enum['id']; 
$result2 = sqlite_unbuffered_query($db, $sql);
#echo "<p>$sql</p>";
?>
	<table>
	<tr>
		<th>Part</th>
		<th>Fuse</th>
		<th>Field</th>
		<th>Mask</th>
		<th>Binary</th>
		<th>Shift</th>
	</tr>
	<?php while($used = sqlite_fetch_array($result2)): ?>
	<tr>
		<td><?= $used['p.description'] ?></td>
		<td><?= $used['fuse'] ?></td>
		<td><?= $used['b.name'] ?></td>
		<td><?= $used['b.mask'] ?></td>
		<td><?= decbin($used['b.mask']) ?></td>
		<td><?= mask2shift((int)$used['b.mask']) ?></td>
	</tr>
	<?php endwhile; ?>
	</table>
<?php endwhile; ?>

</div><!-- /content -->

<?php
sqlite_close($db);
require 'include/footer.php';
?>
